#ifndef AERIALSQUADRON_H
#define AERIALSQUADRON_H
#include "TacticsImplementations.h"

class AerialSquadron : public TacticsImplementation {
public:
	AerialSquadron(Squad* m, AgentPool* p);
	virtual bool execute();
	virtual std::vector<MicroTacticsModel*> getSubTeam(UnitType t);
	virtual void receiveAlert(Unit* t);
	virtual void assignUnit(Unit* u);
	void receiveTarget(Unit* u, int f);
	void broadcastTarget();
private:
	std::vector<MicroTacticsModel*> unitTactics;
	AgentPool* agentPool;
	Squad* element;
	bool dead;
	TargetFitnessCalculator* targetFitnessCalculator;
	std::vector<std::pair<int, Unit*>> squadTargets;
};

#endif