#ifndef MILPROD_GOALHEADERS_H
#define MILPROD_GOALHEADERS_H
#include "GoalGeneratorBase.h"
#include "GoalTypes.h"

class MilitaryProductionManagerAgent;

// marine training goal
class Military_TrainMarineGoalGenerator : public GoalGeneratorBase {
	public:
		Military_TrainMarineGoalGenerator(AgentPool* a, MilitaryProductionManagerAgent* parent);

		// generic stuff
		virtual void inhibit();
		virtual bool instantiateGoal();
		virtual void updateDrives();
		virtual void initialize();
		virtual int getdrive();
		virtual int getthresh();
	
	
	private:

		// generic stuff
		bool inhibited;
		AgentPool* agentPool;
		int drive;
		int thresh;
		int priority;
		MilitaryProductionManagerAgent* parent;
		GoalDescriptor* goal;
		int temporalFactor;

		// implementation-specific stuff, if needed
		

};


class Military_TrainFireBatGoalGenerator : public GoalGeneratorBase {
public:
	Military_TrainFireBatGoalGenerator(AgentPool* a, MilitaryProductionManagerAgent* parent);

	// generic stuff
	virtual void inhibit();
	virtual bool instantiateGoal();
	virtual void updateDrives();
	virtual void initialize();
	virtual int getdrive();
	virtual int getthresh();


private:

	// generic stuff
	bool inhibited;
	AgentPool* agentPool;
	int drive;
	int thresh;
	int priority;
	MilitaryProductionManagerAgent* parent;
	GoalDescriptor* goal;
			int temporalFactor;
	// implementation-specific stuff, if needed


};

class Military_TrainMedicGoalGenerator : public GoalGeneratorBase {
	public:
		Military_TrainMedicGoalGenerator(AgentPool* a, MilitaryProductionManagerAgent* parent);

		// generic stuff
		virtual void inhibit();
		virtual bool instantiateGoal();
		virtual void updateDrives();
		virtual void initialize();
		virtual int getdrive();
		virtual int getthresh();
			
	
	private:

		// generic stuff
		bool inhibited;
		AgentPool* agentPool;
		int drive;
		int thresh;
		int priority;
		MilitaryProductionManagerAgent* parent;
		GoalDescriptor* goal;
				int temporalFactor;
		// implementation-specific stuff, if needed
		

};


// wraith training goal
class Military_TrainFlyerGoalGenerator : public GoalGeneratorBase {
	public:
		Military_TrainFlyerGoalGenerator(AgentPool* a, MilitaryProductionManagerAgent* parent);

		// generic stuff
		virtual void inhibit();
		virtual bool instantiateGoal();
		virtual void updateDrives();
		virtual void initialize();
		virtual int getdrive();
		virtual int getthresh();
				
	
	private:

		// generic stuff
		bool inhibited;
		AgentPool* agentPool;
		int drive;
		int thresh;
		int priority;
		MilitaryProductionManagerAgent* parent;
		GoalDescriptor* goal;
				int temporalFactor;
		// implementation-specific stuff, if needed
		

};


// marine training goal
class Military_TrainTankGoalGenerator : public GoalGeneratorBase {
	public:
		Military_TrainTankGoalGenerator(AgentPool* a, MilitaryProductionManagerAgent* parent);

		// generic stuff
		virtual void inhibit();
		virtual bool instantiateGoal();
		virtual void updateDrives();
		virtual void initialize();
		virtual int getdrive();
		virtual int getthresh();
				
	
	private:

		// generic stuff
		bool inhibited;
		AgentPool* agentPool;
		int drive;
		int thresh;
		int priority;
		MilitaryProductionManagerAgent* parent;
		GoalDescriptor* goal;
				int temporalFactor;
		// implementation-specific stuff, if needed
		

};




// marine training goal
class Military_TrainGoliathGoalGenerator : public GoalGeneratorBase {
	public:
		Military_TrainGoliathGoalGenerator(AgentPool* a, MilitaryProductionManagerAgent* parent);

		// generic stuff
		virtual void inhibit();
		virtual bool instantiateGoal();
		virtual void updateDrives();
		virtual void initialize();
		virtual int getdrive();
		virtual int getthresh();
			
	private:

		// generic stuff
		bool inhibited;
		AgentPool* agentPool;
		int drive;
		int thresh;
		int priority;
		MilitaryProductionManagerAgent* parent;
		GoalDescriptor* goal;
				int temporalFactor;
		// implementation-specific stuff, if needed
		

};

class Military_TrainScienceVesselGoalGenerator : public GoalGeneratorBase {
public:
	Military_TrainScienceVesselGoalGenerator(AgentPool* a, MilitaryProductionManagerAgent* parent);

	// generic stuff
	virtual void inhibit();
	virtual bool instantiateGoal();
	virtual void updateDrives();
	virtual void initialize();
	virtual int getdrive();
	virtual int getthresh();
		
private:

	// generic stuff
	bool inhibited;
	AgentPool* agentPool;
	int drive;
	int thresh;
	int priority;
	MilitaryProductionManagerAgent* parent;
	GoalDescriptor* goal;
			int temporalFactor;
	// implementation-specific stuff, if needed


};



class Military_TrainDropShipGoalGenerator : public GoalGeneratorBase {
public:
	Military_TrainDropShipGoalGenerator(AgentPool* a, MilitaryProductionManagerAgent* parent);

	// generic stuff
	virtual void inhibit();
	virtual bool instantiateGoal();
	virtual void updateDrives();
	virtual void initialize();
	virtual int getdrive();
	virtual int getthresh();
	


private:

	// generic stuff
	bool inhibited;
	AgentPool* agentPool;
	int drive;
	int thresh;
	int priority;
	MilitaryProductionManagerAgent* parent;
	GoalDescriptor* goal;
			int temporalFactor;
	// implementation-specific stuff, if needed


};



class Military_TrainVultureGoalGenerator : public GoalGeneratorBase {
public:
	Military_TrainVultureGoalGenerator(AgentPool* a, MilitaryProductionManagerAgent* parent);

	// generic stuff
	virtual void inhibit();
	virtual bool instantiateGoal();
	virtual void updateDrives();
	virtual void initialize();
	virtual int getdrive();
	virtual int getthresh();



private:

	// generic stuff
	bool inhibited;
	AgentPool* agentPool;
	int drive;
	int thresh;
	int priority;
	MilitaryProductionManagerAgent* parent;
	GoalDescriptor* goal;
			int temporalFactor;
	// implementation-specific stuff, if needed


};



class Military_TrainBattlecruiserGoalGenerator : public GoalGeneratorBase {
public:
	Military_TrainBattlecruiserGoalGenerator(AgentPool* a, MilitaryProductionManagerAgent* parent);

	// generic stuff
	virtual void inhibit();
	virtual bool instantiateGoal();
	virtual void updateDrives();
	virtual void initialize();
	virtual int getdrive();
	virtual int getthresh();



private:

	// generic stuff
	bool inhibited;
	AgentPool* agentPool;
	int drive;
	int thresh;
	int priority;
	MilitaryProductionManagerAgent* parent;
	GoalDescriptor* goal;
			int temporalFactor;
	// implementation-specific stuff, if needed


};

#endif